function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
/**
 * DropdownMenu is component for rendering dropdown menu
 * @param props
 * @returns {XML}
 * @constructor
 */

var DropdownMenu =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(DropdownMenu, _React$Component);

  function DropdownMenu() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = DropdownMenu.prototype;

  _proto.render = function render() {
    var _this = this;

    var _this$props = this.props,
        isNested = _this$props.isNested,
        children = _this$props.children;
    var _this$context = this.context,
        isOpen = _this$context.isOpen,
        visibleClass = _this$context.visibleClass;
    return React.createElement("div", {
      className: "cui-list" + ("" + (isNested ? ' nested' : '')) + ("" + (isOpen ? ' visible' : '')) + (" " + visibleClass),
      ref: function ref(_ref) {
        return _this.menu = _ref;
      },
      role: "menu"
    }, children);
  };

  return DropdownMenu;
}(React.Component);

DropdownMenu.displayName = 'DropdownMenu';
export { DropdownMenu as default };
DropdownMenu.contextTypes = {
  /** optional isOpen prop type */
  isOpen: PropTypes.bool,

  /** optional visibleClass prop type */
  visibleClass: PropTypes.string
};
DropdownMenu.propTypes = {
  /** optional nested boolean */
  isNested: PropTypes.bool,

  /** required function for onClick events */
  children: PropTypes.node
};
DropdownMenu.defaultProps = {
  isOpen: false,
  visibleClass: '',
  isNested: false,
  children: null
};