function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

import React from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
/**
 * IsVisible is component for determining if single child is visible on screen
 * @param props
 * @returns {XML}
 * @constructor
 */

var IsVisible =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(IsVisible, _React$Component);

  function IsVisible() {
    var _temp, _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (_temp = _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this, _this.state = {
      visibleClass: ''
    }, _this.getChildContext = function () {
      return {
        visibleClass: _this.state.visibleClass
      };
    }, _this.isVisible = function (element) {
      var tempParentArr = [];
      var elementBoundingRect = element.getBoundingClientRect();
      var elementParent = element.parentElement;
      var windowBottom = window.pageXOffset + window.innerHeight;
      var elementTop = elementBoundingRect.top - 36 - elementBoundingRect.height;
      var elementBottom = elementBoundingRect.bottom;

      var findParents = function findParents(elem) {
        return !elem.parentElement ? tempParentArr : findParents(elem.parentElement, tempParentArr.push(elem));
      };

      var elementParents = findParents(elementParent);

      var findOverflow = function findOverflow(node) {
        var searchProps = ['overflow', 'overflow-y'];
        return searchProps.reduce(function (agg, prop) {
          var overflowElement = ReactDOM.findDOMNode(node).style[prop];
          return !overflowElement || agg.includes(overflowElement) ? agg : agg += overflowElement;
        }, '');
      };

      var findScrollParent = function findScrollParent() {
        var overflowElement = null;
        var idx = 0;

        while (!overflowElement && elementParents[idx]) {
          if (/(auto|scroll)/.test(findOverflow(elementParents[idx]))) {
            return overflowElement = elementParents[idx];
          }

          idx++;
        }

        return overflowElement ? overflowElement : window;
      };

      var scrollParent = findScrollParent(element);
      var parentBottom = !!scrollParent.getBoundingClientRect && scrollParent.getBoundingClientRect().bottom || windowBottom;
      var parentTop = !!scrollParent.getBoundingClientRect && scrollParent.getBoundingClientRect().top || 0;
      return elementBottom < windowBottom && elementBottom < parentBottom || elementTop < 0 && elementTop < parentTop;
    }, _this.chooseClass = function (isOpen) {
      return isOpen && _this.isVisible(ReactDOM.findDOMNode(_this.dropdown)) ? _this.setState({
        visibleClass: 'bottom'
      }) : _this.setState({
        visibleClass: 'top'
      });
    }, _temp) || _assertThisInitialized(_this);
  }

  var _proto = IsVisible.prototype;

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    prevProps !== this.props && this.chooseClass(this.props.isOpen);
  };

  _proto.render = function render() {
    var _this2 = this;

    var children = this.props.children;
    return React.cloneElement(children, {
      ref: function ref(_ref) {
        return _this2.dropdown = _ref;
      }
    });
  };

  return IsVisible;
}(React.Component);

IsVisible.displayName = 'IsVisible';
export { IsVisible as default };
IsVisible.childContextTypes = {
  /** Class to be applied to child element. */
  visibleClass: PropTypes.string
};
IsVisible.propTypes = {
  /** Open prop as to whether component is open */
  isOpen: PropTypes.bool.isRequired,

  /** Child component to display next to the input */
  children: PropTypes.element.isRequired
};