function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { ModalHeader } from "./..";
/** Library that manages Tabbing and Accessibility for Modal
 *   https://github.com/davidtheclark/react-aria-modal
 */

import AriaModal from 'react-aria-modal';
/**
 * @category containers
 * @component modal
 * @variations collab-ui-react
 */

var Modal =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Modal, _React$Component);

  function Modal() {
    var _temp, _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (_temp = _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this, _this.state = {
      animationClass: ''
    }, _this.closeModal = function () {
      _this.setState({
        animationClass: ''
      });

      return setTimeout(function () {
        _this.props.onHide();
      }, 300);
    }, _temp) || _assertThisInitialized(_this);
  }

  var _proto = Modal.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var _this2 = this;

    this.props.show !== nextProps.show && nextProps.show && setTimeout(function () {
      _this2.setState({
        animationClass: 'in'
      });
    }, 0);
  };

  _proto.render = function render() {
    var _this3 = this;

    var _this$props = this.props,
        show = _this$props.show,
        className = _this$props.className,
        size = _this$props.size,
        backdrop = _this$props.backdrop,
        backdropClickExit = _this$props.backdropClickExit,
        escapeExits = _this$props.escapeExits,
        htmlId = _this$props.htmlId,
        headerLabel = _this$props.headerLabel,
        showCloseButton = _this$props.showCloseButton,
        applicationId = _this$props.applicationId,
        icon = _this$props.icon,
        focusDialog = _this$props.focusDialog,
        renderTo = _this$props.renderTo,
        props = _objectWithoutProperties(_this$props, ["show", "className", "size", "backdrop", "backdropClickExit", "escapeExits", "htmlId", "headerLabel", "showCloseButton", "applicationId", "icon", "focusDialog", "renderTo"]);

    var getIcon = function getIcon() {
      if (icon.type.displayName === 'Icon') {
        return icon;
      }

      throw new Error("icon prop needs to be of type Icon.");
    };

    var modalContent = React.createElement("div", {
      className: "cui-modal__content"
    }, icon && size === 'dialog' && getIcon() && React.createElement("div", {
      className: "cui-modal__left-pane"
    }, icon), React.createElement("div", {
      className: "cui-modal__right-pane"
    }, headerLabel && React.createElement(ModalHeader, {
      showCloseButton: showCloseButton,
      headerLabel: headerLabel,
      onHide: this.closeModal
    }), this.props.children));
    var RenderModal = renderTo ? AriaModal.renderTo("#" + renderTo) : AriaModal;

    var getModal = function getModal() {
      return show && React.createElement(RenderModal, _extends({
        onExit: _this3.closeModal,
        getApplicationNode: function getApplicationNode() {
          return document.querySelector("#" + applicationId);
        },
        dialogClass: "cui-modal" + (" cui-modal--" + size) + (" " + _this3.state.animationClass) + ("" + (className && " " + className || '')),
        includeDefaultStyles: false,
        titleId: htmlId,
        underlayClass: backdrop ? "cui-modal__backdrop fade" + (" " + _this3.state.animationClass) : '',
        underlayClickExits: backdropClickExit,
        escapeExits: escapeExits,
        focusDialog: focusDialog
      }, props), modalContent);
    };

    return getModal();
  };

  return Modal;
}(React.Component);

Modal.displayName = 'Modal';
Modal.defaultProps = {
  children: null,
  show: false,
  size: 'default',
  backdrop: true,
  className: '',
  showCloseButton: true,
  headerLabel: '',
  backdropClickExit: false,
  escapeExits: true,
  icon: null,
  focusDialog: true,
  renderTo: null
};
Modal.propTypes = {
  /** Unique HTML ID. Used for tying label to HTML input. Handy hook for automated testing. */
  htmlId: PropTypes.string.isRequired,

  /**
   * Children components
   */
  children: PropTypes.node,

  /**
   * show/hide modal.
   */
  show: PropTypes.bool.isRequired,

  /**
   * size of the modal.
   */
  size: PropTypes.oneOf(['default', 'small', 'full', 'dialog']),

  /**
   * callback function invoked on close of the modal. modal can be closed on click of cross button or esc key.
   * onHide is mandatory props, if not passed modal can not be closed.
   */
  onHide: PropTypes.func.isRequired,

  /**
   * css class names
   */
  className: PropTypes.string,

  /**
   *  To show/hide backdrop of the modal.
   *  if backdrop is false then modal will become normal popup without backdrop and user can perform any action in parent screen.
   */
  backdrop: PropTypes.bool,

  /**
   *  To enable/disable clicking on underlay to exit modal
   *
   */
  backdropClickExit: PropTypes.bool,

  /**
   *  To enable/disable escape to exit modal
   *
   */
  escapeExits: PropTypes.bool,

  /**
   * header label.
   */
  headerLabel: PropTypes.string,

  /**
   * show/hide close button
   */
  showCloseButton: PropTypes.bool,

  /**
   * application DOM id, used to set aria-hidden to true when modal is open.
   */
  applicationId: PropTypes.string.isRequired,

  /**
   * Icon node to be rendered for Dialog
   */
  icon: PropTypes.element,

  /**
   * To set focus to the entire modal rather than elements within modal
   */
  focusDialog: PropTypes.bool,

  /**
  * To render to an element other than the window
  */
  renderTo: PropTypes.string
};
export default Modal;
/**
* @name Default Modal
* @description Modal with default size.
* @category containers
* @component modal
* @section default
*
* @js

import {
  Button,
  ModalBody,
  ModalFooter
} from '@collab-ui/react';

export default class Default extends React.PureComponent {
  state = {
    showModal: false
  }

  render() {
    return (
      <section>
        <div className='row'>
          <div>
            <Button
              children='Default Modal'
              onClick={() => this.setState({showModal: true})}
              ariaLabel='Open Modal'
              color='primary'
              size='large'
            />
          </div>
        </div>
        <div>
          <Modal
            applicationId='app'
            onHide={() => this.setState({showModal: false})}
            headerLabel='Default Modal'
            show={this.state.showModal}
            ref={modal1 => this.modal1 = modal1}
            htmlId='modal1'
          >
            <ModalBody>
              <form ref={form1 => this.form1 = form1} />
            </ModalBody>
            <ModalFooter>
              <Button
                children='Cancel'
                onClick={() => this.modal1.closeModal()}
                ariaLabel='Close Modal'
                color='default'
              />
              <Button
                children='OK'
                type='submit'
                onClick={(e) => {
                  e.preventDefault();
                  this.modal1.closeModal();
                }}
                ariaLabel='Submit Form'
                color='primary'
              />
            </ModalFooter>
          </Modal>
        </div>
      </section>
    );
  }
}

**/

/**
* @name Dialog Modal
* @description Modal with dialog size.
* @category containers
* @component modal
* @section dialog
*
* @js

import {
  Button,
  ModalBody,
  ModalFooter,
  Icon
} from '@collab-ui/react';

export default class Default extends React.PureComponent {
  state = {
    showModal2: false,
    showModalInternal: false
  }

  render() {
    return (
      <section>
        <div className='row'>
          <div>
            <Button
              children='Dialog Modal'
              onClick={() => this.setState({showModal2: true})}
              ariaLabel='Open Modal'
              color='primary'
              size='large'
            />
            <Button
              children='Render To Div'
              onClick={() => this.setState({showModalInternal: true})}
              ariaLabel='Open Modal'
              color='primary'
              size='large'
            />
          </div>
        </div>
        <div>
          <Modal
            icon={<Icon name="warning_72" color="$yellow"/>}
            applicationId='app'
            onHide={() => this.setState({showModal2: false})}
            headerLabel='Dialog Modal'
            show={this.state.showModal2}
            ref={modal2 => this.modal2 = modal2}
            size='dialog'
            htmlId='modal2'
          >
            <ModalBody>
              <span>I'm just a dialog box</span>
            </ModalBody>
            <ModalFooter>
              <Button
                children='Cancel'
                onClick={() => this.modal2.closeModal()}
                ariaLabel='Close Modal'
                color='default'
              />
              <Button
                children='OK'
                onClick={() => this.modal2.closeModal()}
                ariaLabel='Submit Form'
                color='primary'
              />
            </ModalFooter>
          </Modal>
        </div>
        <div id='render-to-modal'/>
        <div>
          <Modal
            icon={<Icon name="warning_72" color="$yellow"/>}
            applicationId='app'
            onHide={() => this.setState({showModalInternal: false})}
            headerLabel='Dialog Modal'
            show={this.state.showModalInternal}
            ref={ref => this.modalInternal = ref}
            size='dialog'
            htmlId='modalInternal'
            renderTo='render-to-modal'
          >
            <ModalBody>
              <span>I'm just a dialog box</span>
            </ModalBody>
            <ModalFooter>
              <Button
                children='Cancel'
                onClick={() => this.modalInternal.closeModal()}
                ariaLabel='Close Modal'
                color='default'
              />
              <Button
                children='OK'
                onClick={() => this.modalInternal.closeModal()}
                ariaLabel='Submit Form'
                color='primary'
              />
            </ModalFooter>
          </Modal>
        </div>
      </section>
    );
  }
}

**/

/**
* @name Small Modal
* @description Modal with small size.
* @category containers
* @component modal
* @section small
*
* @js

import {
  Button,
  ModalBody,
  ModalFooter,
  Form
} from '@collab-ui/react';

export default class Default extends React.PureComponent {
  state = {
    showModal3: false
  }

  render() {
    return (
      <section>
        <div className='row'>
          <div>
            <Button
              children='Small Modal'
              onClick={() => this.setState({showModal3: true})}
              ariaLabel='Open Modal'
              color='primary'
              size='large'
            />
          </div>
        </div>
        <div>
          <Modal
            applicationId='app'
            onHide={() => this.setState({showModal3: false})}
            headerLabel='Small Modal'
            show={this.state.showModal3}
            ref={modal3 => this.modal3 = modal3}
            size='small'
            htmlId='modal3'
          >
            <ModalBody>
              <form ref={moform2 => this.moform2 = moform2} />
            </ModalBody>
            <ModalFooter>
              <Button
                children='Cancel'
                onClick={() => this.modal3.closeModal()}
                ariaLabel='Close Modal'
                color='default'
              />
              <Button
                children='OK'
                type='submit'
                onClick={(e) => {
                  e.preventDefault;
                  this.modal3.closeModal();
                }}
                ariaLabel='Submit Form'
                color='primary'
              />
            </ModalFooter>
          </Modal>
        </div>
      </section>
    );
  }
}
**/

/**
* @name Full Modal
 * @description Modal with full size.
* @category containers
* @component modal
* @section full
*
* @js

import {
  Button,
  ModalBody,
  ModalFooter
} from '@collab-ui/react';

export default class Default extends React.PureComponent {
  state = {
    showModal: false
  }

  render() {
    return (
      <section>
        <div className='row'>
          <div>
            <Button
              children='Full Modal'
              onClick={() => this.setState({showModal: true})}
              ariaLabel='Open Modal'
              color='primary'
              size='large'
            />
          </div>
        </div>
        <div>
          <Modal
            applicationId='app'
            onHide={() => this.setState({showModal: false})}
            headerLabel='Default Modal'
            show={this.state.showModal}
            ref={modal1 => this.modal1 = modal1}
            htmlId='modal1'
            size='full'
          >
            <ModalBody>
              <form ref={form1 => this.form1 = form1} />
            </ModalBody>
            <ModalFooter>
              <Button
                children='Cancel'
                onClick={() => this.modal1.closeModal()}
                ariaLabel='Close Modal'
                color='default'
              />
              <Button
                children='OK'
                type='submit'
                onClick={(e) => {
                  e.preventDefault();
                  this.modal1.closeModal();
                }}
                ariaLabel='Submit Form'
                color='primary'
              />
            </ModalFooter>
          </Modal>
        </div>
      </section>
    );
  }
}
**/