function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { EventOverlay } from "./..";
/**
 * @category communication
 * @component popover
 * @variations collab-ui-react
 */

var Popover =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Popover, _React$Component);

  function Popover() {
    var _temp, _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (_temp = _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this, _this.state = {
      isOpen: false
    }, _this.delayedHide = function (e) {
      if (_this.showTimerId) {
        clearTimeout(_this.showTimerId);
        _this.showTimerId = null;
      }

      var delay = _this.props.hideDelay ? _this.props.hideDelay : _this.props.delay;
      _this.hideTimerId = setTimeout(function () {
        _this.hideTimerId = null;

        _this.setState({
          isOpen: false
        });
      }, delay);
      e.stopPropagation();
    }, _this.delayedShow = function (e) {
      if (_this.hideTimerId) {
        clearTimeout(_this.hideTimerId);
        _this.hideTimerId = null;
      }

      var delay = _this.props.showDelay ? _this.props.showDelay : _this.props.delay;
      _this.showTimerId = setTimeout(function () {
        _this.showTimerId = null;

        _this.setState({
          isOpen: true
        });
      }, delay);
      e.stopPropagation();
    }, _this.handleToggle = function () {
      _this.setState({
        isOpen: !_this.state.isOpen
      });
    }, _this.handleClose = function () {
      _this.setState({
        isOpen: false
      });
    }, _this.handleMouseEnter = function (e) {
      return !_this.showTimerId && !_this.state.isOpen && _this.delayedShow(e);
    }, _this.handleMouseLeave = function (e) {
      if (_this.hasFocus) {
        return false;
      }

      return !_this.hideTimerId && _this.state.isOpen && _this.delayedHide(e);
    }, _this.handleBlur = function (e) {
      _this.hasFocus = false;

      _this.handleMouseLeave(e);
    }, _this.handleFocus = function (e) {
      _this.hasFocus = true;
      return !_this.showTimerId && !_this.state.isOpen && _this.delayedShow(e);
    }, _temp) || _assertThisInitialized(_this);
  }

  var _proto = Popover.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.hideTimerId && clearTimeout(this.hideTimerId);
    this.showTimerId && clearTimeout(this.showTimerId);
  };

  _proto.render = function render() {
    var _this2 = this;

    var isOpen = this.state.isOpen;

    var _this$props = this.props,
        children = _this$props.children,
        popoverTrigger = _this$props.popoverTrigger,
        className = _this$props.className,
        showArrow = _this$props.showArrow,
        direction = _this$props.direction,
        content = _this$props.content,
        closeOnClick = _this$props.closeOnClick,
        props = _objectWithoutProperties(_this$props, ["children", "popoverTrigger", "className", "showArrow", "direction", "content", "closeOnClick"]);

    var getTriggers = function getTriggers() {
      var triggerProps = {};

      triggerProps.ref = function (ele) {
        return _this2.anchorRef = ele;
      };

      triggerProps.key = 'child-1';

      switch (popoverTrigger) {
        case 'MouseEnter':
          triggerProps.onMouseEnter = _this2.handleMouseEnter;
          triggerProps.onMouseLeave = _this2.handleMouseLeave;
          triggerProps.onFocus = _this2.handleFocus;
          triggerProps.onBlur = _this2.handleBlur;
          break;

        case 'Click':
          triggerProps.onClick = _this2.handleFocus;
          triggerProps.onFocus = _this2.handleFocus;
          triggerProps.onBlur = null;
          triggerProps.onMouseEnter = null;
          triggerProps.onMouseLeave = null;
          break;

        case 'Focus':
          triggerProps.onFocus = _this2.handleFocus;
          triggerProps.onBlur = null;
          triggerProps.onMouseEnter = null;
          triggerProps.onMouseLeave = null;
          break;
      }

      return triggerProps;
    };

    var anchorWithTriggers = children && React.cloneElement(children, getTriggers());
    return React.createElement("div", null, anchorWithTriggers, React.createElement(EventOverlay, _extends({
      ref: function ref(_ref) {
        return _this2.overlay = _ref;
      },
      allowClickAway: true,
      anchorNode: this.anchorRef,
      isOpen: isOpen,
      className: className,
      showArrow: showArrow,
      direction: direction,
      close: this.handleClose,
      closeOnClick: closeOnClick
    }, props), content));
  };

  return Popover;
}(React.Component);

Popover.displayName = 'Popover';
Popover.defaultProps = {
  className: '',
  direction: 'top-center',
  popoverTrigger: 'MouseEnter',
  showArrow: true,
  showDelay: 0,
  hideDelay: 0,
  delay: 0,
  closeOnClick: false
};
Popover.propTypes = {
  /**
   * Event that will trigger popover appearance
   */
  popoverTrigger: PropTypes.oneOf(['MouseEnter', 'Click', 'Focus']),

  /**
   * optional direction of popover
   */
  direction: PropTypes.oneOf(['top-center', 'top-left', 'top-right', 'left-center', 'left-top', 'left-bottom', 'bottom-center', 'bottom-left', 'bottom-right', 'right-center', 'right-top', 'right-bottom']),

  /**
   * css class names which goes over popover container
   */
  className: PropTypes.string,

  /**
   * this should be the popover trigger(this should be a stateful component)
   */
  children: PropTypes.element.isRequired,

  /**
   * the content that goes into the popover
   */
  content: PropTypes.oneOfType([PropTypes.element, PropTypes.node]).isRequired,
  showArrow: PropTypes.bool,

  /**
   * the show delay for popover on hover and focus
   */
  showDelay: PropTypes.number,

  /**
   * the hide delay for popover on hover and focus
   */
  hideDelay: PropTypes.number,

  /**
   * the delay for popover on hover and focus (hide/show)
   */
  delay: PropTypes.number,

  /**
   * property which decides to close the popover on click of it
   */
  closeOnClick: PropTypes.bool
};
export default Popover;
/**
* @name Popover Default with Delay
*
* @category communication
* @component popover
* @section default
*
* @js

 import {
  Button
} from '@collab-ui/react';

 export default function Default() {
 const content = (
      <span key="1" style={{ padding: '10px'}}>Popover bottom</span>
    );
  return(
    <div className='row'>
      <div>
        <Popover
          content={content}
          direction={'bottom-center'}
          delay={200}
          popoverTrigger={'MouseEnter'}
          targetOffset={{vertical: 10}}
          isDynamic
        >
          <Button
            children='Hover'
            ariaLabel='Hover'
            color='primary'
            onClick={()=>{}}
          />
        </Popover>
      </div>
      <br />
    </div>
  );
}
**/

/**
* @name Popover on Click
*
* @category communication
* @component popover
* @section onclick
*
* @js

 import {
  Button
} from '@collab-ui/react';

 export default function PopOverClick() {
 const content = (
      <span key="1" style={{ padding: '10px'}}>Popover top</span>
    );
  return(
    <div className='row'>
      <br />
      <div>
        <Popover
          content={content}
          direction={'top-center'}
          popoverTrigger={'Click'}
          targetOffset={{vertical: 10}}
        >
          <Button
            children='Click'
            ariaLabel='Click'
            color='primary'
            onClick={()=>{}}
          />
        </Popover>
      </div>
      <br />
    </div>
  );
}
**/

/**
* @name Popover on Focus
*
* @category communication
* @component popover
* @section onfocus
*
* @js

 import {
  Button
} from '@collab-ui/react';

 export default function PopOverFocus() {
  const contentLeft = (
    <span key="1" style={{ padding: '10px'}}>Popover left</span>
  );
  const contentRight = (
    <span key="1" style={{ padding: '10px'}}>Popover right</span>
  );
  return(
    <div className='row'>
      <br />
      <div>
        <Popover
          content={contentRight}
          direction={'right-center'}
          popoverTrigger={'Focus'}
          targetOffset={{horizontal: 10}}
        >
          <Button
            children='Focus Right'
            ariaLabel='Focus Right'
            color='primary'
            onClick={()=>{}}
          />
        </Popover>
      </div>
      <br />
      <div>
        <Popover
          content={contentLeft}
          direction={'left-center'}
          popoverTrigger={'Focus'}
          targetOffset={{horizontal: 10}}
        >
          <Button
            children='Focus Left'
            ariaLabel='Focus Left'
            color='primary'
            onClick={()=>{}}
          />
        </Popover>
      </div>
      <br />
    </div>
  );
}
**/