"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ = require("../..");

var _lodash = require("lodash");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var DeviceListCall =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(DeviceListCall, _React$PureComponent);

  function DeviceListCall() {
    var _temp, _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (_temp = _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this, _this.state = {
      selectedIndex: _this.props.defaultSelected,
      id: (0, _lodash.uniqueId)(_this.props.id && _this.props.id + "-" || 'cui-device-list-call-')
    }, _this.handleSelect = function (e, value, index) {
      var _this$props = _this.props,
          onSelect = _this$props.onSelect,
          devices = _this$props.devices;
      var currentIndex = devices.length < index - 1 ? 0 : index - 1;
      e.preventDefault();
      return _this.setState({
        selectedIndex: currentIndex
      }, function () {
        return onSelect && onSelect(e, currentIndex, value);
      });
    }, _temp) || _assertThisInitialized(_this);
  }

  var _proto = DeviceListCall.prototype;

  _proto.render = function render() {
    var _this$props2 = this.props,
        className = _this$props2.className,
        header = _this$props2.header,
        devices = _this$props2.devices;
    var _this$state = this.state,
        selectedIndex = _this$state.selectedIndex,
        id = _this$state.id;

    var getLeftSection = function getLeftSection(deviceType) {
      switch (deviceType) {
        case 'device':
          return _react.default.createElement(_.Icon, {
            name: "spark-board_20"
          });

        default:
          return _react.default.createElement(_.Icon, {
            name: "laptop_20"
          });
      }
    };

    var getRightSection = function getRightSection(device, idx) {
      if (idx === selectedIndex) {
        return _react.default.createElement(_.Icon, {
          name: "check_20",
          color: "blue"
        });
      }
    };

    return _react.default.createElement(_.List, {
      className: className,
      onSelect: this.handleSelect,
      active: selectedIndex
    }, _react.default.createElement(_.ListItemHeader, {
      header: header
    }), devices.map(function (ele, idx) {
      return _react.default.createElement(_.ListItem, {
        key: "device-" + idx,
        id: id,
        value: ele,
        label: ele.name
      }, _react.default.createElement(_.ListItemSection, {
        position: "left"
      }, getLeftSection(ele.type)), _react.default.createElement(_.ListItemSection, {
        position: "center"
      }, _react.default.createElement("div", {
        className: "cui-list-item__header"
      }, ele.name)), _react.default.createElement(_.ListItemSection, {
        position: "right"
      }, getRightSection(ele, idx)));
    }));
  };

  return DeviceListCall;
}(_react.default.PureComponent);

exports.default = DeviceListCall;
DeviceListCall.displayName = 'DeviceListCall';
DeviceListCall.defaultProps = {
  className: '',
  childrenLeft: null,
  childrenRight: null,
  id: null,
  onSelect: null,
  defaultSelected: 0
};
DeviceListCall.propTypes = {
  defaultSelected: _propTypes.default.number,

  /** HTML Class for associated input */
  className: _propTypes.default.string,

  /** ListItem header */
  header: _propTypes.default.string.isRequired,

  /** HTML ID for associated input */
  id: _propTypes.default.string,

  /** optional function called when list item is selected */
  onSelect: _propTypes.default.func,

  /** required list of devices to show in list */
  devices: _propTypes.default.arrayOf(_propTypes.default.shape({
    name: _propTypes.default.string.isRequired,
    value: _propTypes.default.string,
    type: _propTypes.default.oneOf(['', 'device'])
  })).isRequired
};