"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

/**
 * Collapse is component for rendering dropdown menu
 * @param props
 * @returns {XML}
 * @constructor
 */
var Collapse =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Collapse, _React$Component);

  function Collapse() {
    var _temp, _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return (_temp = _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this, _this.state = {
      dropdownClass: ''
    }, _temp) || _assertThisInitialized(_this);
  }

  var _proto = Collapse.prototype;

  _proto.componentDidUpdate = function componentDidUpdate(nextProps) {
    var _this2 = this;

    window.requestAnimationFrame(function () {
      return _this2.props.isOpen !== nextProps.isOpen && nextProps.isOpen ? _this2.setState({
        dropdownClass: 'in'
      }) : _this2.setState({
        dropdownClass: ''
      });
    });
  };

  _proto.render = function render() {
    var _this$props = this.props,
        isOpen = _this$props.isOpen,
        children = _this$props.children;
    var dropdownClass = this.state.dropdownClass;
    var changeHeight = isOpen ? {
      height: 'auto'
    } : {
      height: '0px'
    };
    return _react.default.createElement("div", null, _react.default.createElement("hr", null), _react.default.createElement("collapse", {
      className: "collapse" + ("" + dropdownClass),
      "aria-expanded": isOpen,
      "aria-hidden": !isOpen,
      style: changeHeight
    }, _react.default.createElement("div", {
      className: "well well-lg"
    }, children)));
  };

  return Collapse;
}(_react.default.Component);

exports.default = Collapse;
Collapse.displayName = 'Collapse';
Collapse.defaultProps = {
  children: null,
  isOpen: false
};
Collapse.propTypes = {
  // show/hide modal.
  isOpen: _propTypes.default.bool.isRequired,
  // Children components
  children: _propTypes.default.node
}; // export default Collapse;

/**
* @name Collapse
* @description Default Collapse
* @category containers
* @component collapse
* @section default
*
* @js
import { Button } from '@collab-ui/react';

export default class Collapse extends React.PureComponent {
  state = {
    showCollapseBody: true,
  }

  render() {
    return (
     <div>
       <div>
         <Collapse
           show={this.state.showCollapseBody}
         >
           <div>Test</div>
         </Collapse>
       </div>
       <div>
         <div className='row'>
           <br />
           <Button
             onClick={() => this.setState({showCollapseBody: !this.state.showCollapseBody})}
             ariaLabel='Toggle Collapse'
             className='btn--primary btn--large'
           >
            Toggle Collapse
           </Button>
         </div>
       </div>
     </div>
    );
  }
}
**/