"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

/**
 * DropdownMenu is component for rendering dropdown menu
 * @param props
 * @returns {XML}
 * @constructor
 */
var DropdownMenu =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(DropdownMenu, _React$Component);

  function DropdownMenu() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = DropdownMenu.prototype;

  _proto.render = function render() {
    var _this = this;

    var _this$props = this.props,
        isNested = _this$props.isNested,
        children = _this$props.children;
    var _this$context = this.context,
        isOpen = _this$context.isOpen,
        visibleClass = _this$context.visibleClass;
    return _react.default.createElement("div", {
      className: "cui-list" + ("" + (isNested ? ' nested' : '')) + ("" + (isOpen ? ' visible' : '')) + (" " + visibleClass),
      ref: function ref(_ref) {
        return _this.menu = _ref;
      },
      role: "menu"
    }, children);
  };

  return DropdownMenu;
}(_react.default.Component);

exports.default = DropdownMenu;
DropdownMenu.displayName = 'DropdownMenu';
DropdownMenu.contextTypes = {
  /** optional isOpen prop type */
  isOpen: _propTypes.default.bool,

  /** optional visibleClass prop type */
  visibleClass: _propTypes.default.string
};
DropdownMenu.propTypes = {
  /** optional nested boolean */
  isNested: _propTypes.default.bool,

  /** required function for onClick events */
  children: _propTypes.default.node
};
DropdownMenu.defaultProps = {
  isOpen: false,
  visibleClass: '',
  isNested: false,
  children: null
};