"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @category controls
 * @component label
 * @variations collab-ui-react
 */
var Label = function Label(_ref) {
  var className = _ref.className,
      label = _ref.label,
      htmlFor = _ref.htmlFor;
  return _react.default.createElement("label", {
    className: className,
    htmlFor: htmlFor
  }, _react.default.createElement("span", null, label));
};

Label.defaultProps = {
  className: ''
};
Label.propTypes = {
  /** HTML ID for associated input */
  htmlFor: _propTypes.default.string.isRequired,

  /** HTML Class for associated input */
  className: _propTypes.default.string,

  /** Label text */
  label: _propTypes.default.string.isRequired
};
Label.displayName = 'Label';
var _default = Label;
/**
* @name Default Label
* @description Labels are useful.
*
* @category controls
* @component label
* @section default
*
* @js

export default function Default() {
  return (
    <div className='row'>
      <Label
        htmlFor='label1'
        label='Default Label'
      />
    </div>
  );
}

**/

exports.default = _default;